<template lang="fr">
  <div class="planets-page">
    <h1>List of planets</h1>
    <FilterCheckbox :id="'checkedIsPlanet'" :label="'Only planets ?'" v-model="checkedIsPlanet" @update="onFilter"/>
    <FilterCheckbox :id="'checkedHasMoons'" :label="'Has moons ?'" v-model="checkedHasMoons" @update="onFilter"/>
    <Table :datas="filteredPlanets" />
  </div>
</template>

<script>
import PlanetAPI from "./../services/index";
import Table from "./../components/Table";
import FilterCheckbox from "./../components/FilterCheckbox";

export default {
  name: "PlanetsPage",
  components: {
    Table,
    FilterCheckbox,
  },
  data() {
    return {
      planets: {},
      checkedIsPlanet: false,
      checkedHasMoons: false,
    };
  },
  computed: {
    filteredPlanets() {
      if (this.checkedIsPlanet && this.checkedHasMoons) {
        return this.planets
          .filter((planet) => planet.isPlanet === true)
          .filter((planet) => planet.moons !== null);
      }
      if (this.checkedIsPlanet) {
        return this.planets.filter((planet) => planet.isPlanet === true);
      }
      if (this.checkedHasMoons) {
        return this.planets.filter((planet) => planet.moons !== null);
      }

      return this.planets;
    },
  },
  methods: {
    async fetchPlanets() {
      this.planets = await PlanetAPI.findAll();
    },
    onFilter({ target }) {
      target.name === "checkedIsPlanet" &&
        (this.checkedIsPlanet = target.checked);

      target.name === "checkedHasMoons" &&
        (this.checkedHasMoons = target.checked);
    },
  },
  mounted() {
    this.fetchPlanets();
  },
};
</script>
